# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
import grpc

from . import lazo_index_pb2 as lazo__index__pb2


class LazoIndexStub(object):
  """Service responsible for indexing the values of a textual or categorical
  column using Lazo.
  """

  def __init__(self, channel):
    """Constructor.

    Args:
      channel: A grpc.Channel.
    """
    self.IndexData = channel.stream_unary(
        '/lazo_index.LazoIndex/IndexData',
        request_serializer=lazo__index__pb2.ColumnValue.SerializeToString,
        response_deserializer=lazo__index__pb2.LazoSketchData.FromString,
        )
    self.IndexDataPath = channel.unary_unary(
        '/lazo_index.LazoIndex/IndexDataPath',
        request_serializer=lazo__index__pb2.DataPath.SerializeToString,
        response_deserializer=lazo__index__pb2.LazoSketchDataList.FromString,
        )
    self.QueryData = channel.stream_unary(
        '/lazo_index.LazoIndex/QueryData',
        request_serializer=lazo__index__pb2.Value.SerializeToString,
        response_deserializer=lazo__index__pb2.LazoQueryResults.FromString,
        )
    self.QueryDataPath = channel.unary_unary(
        '/lazo_index.LazoIndex/QueryDataPath',
        request_serializer=lazo__index__pb2.DataPath.SerializeToString,
        response_deserializer=lazo__index__pb2.LazoQueryResultsList.FromString,
        )


class LazoIndexServicer(object):
  """Service responsible for indexing the values of a textual or categorical
  column using Lazo.
  """

  def IndexData(self, request_iterator, context):
    """Obtains a stream of values from a column and returns its
    corresponding Lazo sketch.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def IndexDataPath(self, request, context):
    """Obtains the path for a dataset and a set of columns,
    and returns their corresponding Lazo sketches.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def QueryData(self, request_iterator, context):
    """Obtains a stream of values from an input column, queries the Lazo index,
    and returns all the datasets that intersect with that input column.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def QueryDataPath(self, request, context):
    """Obtains the path for a dataset and a set of columns, queries the Lazo index,
    and returns all the datasets that intersect with the input columns.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')


def add_LazoIndexServicer_to_server(servicer, server):
  rpc_method_handlers = {
      'IndexData': grpc.stream_unary_rpc_method_handler(
          servicer.IndexData,
          request_deserializer=lazo__index__pb2.ColumnValue.FromString,
          response_serializer=lazo__index__pb2.LazoSketchData.SerializeToString,
      ),
      'IndexDataPath': grpc.unary_unary_rpc_method_handler(
          servicer.IndexDataPath,
          request_deserializer=lazo__index__pb2.DataPath.FromString,
          response_serializer=lazo__index__pb2.LazoSketchDataList.SerializeToString,
      ),
      'QueryData': grpc.stream_unary_rpc_method_handler(
          servicer.QueryData,
          request_deserializer=lazo__index__pb2.Value.FromString,
          response_serializer=lazo__index__pb2.LazoQueryResults.SerializeToString,
      ),
      'QueryDataPath': grpc.unary_unary_rpc_method_handler(
          servicer.QueryDataPath,
          request_deserializer=lazo__index__pb2.DataPath.FromString,
          response_serializer=lazo__index__pb2.LazoQueryResultsList.SerializeToString,
      ),
  }
  generic_handler = grpc.method_handlers_generic_handler(
      'lazo_index.LazoIndex', rpc_method_handlers)
  server.add_generic_rpc_handlers((generic_handler,))
